// Pixie.cpp : AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"
#include "resource.h"
#include <commctrl.h>
#include <commdlg.h>
#include "setting.h"

#define TITLE		TEXT("PixieWindow")

#define DLG_WIDTH		240
int iDlgWidth, iDlgHeight;	// sNZPʂł̃_CAO̕ƍ

// gsGetFile.dll ̊֐錾
BOOL gsGetOpenFileName(OPENFILENAME* pofn);
BOOL gsGetSaveFileName(OPENFILENAME* pofn);

// winlist.cpp
HWND GetNextTopWindow(void);
BOOL CALLBACK WinlistDlgFunc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

// DlgBrackets.cpp
LRESULT CALLBACK DlgBrackets(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL ReadFileFreeWord(HWND hWnd, LPTSTR szFileName);

HINSTANCE			g_hInst;					// The current instance
HWND				hWndMain;
HWND				hWndEdit = 0;

static TCHAR		szIniName[256] = _T("Pixie.ini");

struct DLGITEM_T {
	int id;
	int left;
	int top;
	int right;
	int bottom;
};
static int iDlgItemId[] = {
	IDC_EDIT1,
	IDC_BUTTON1,
	IDC_BUTTON4,
	IDC_BUTTON7,
	IDC_BUTTON6,
	IDC_BUTTON8,
	IDC_BUTTON2,
	//IDC_BUTTON3,
	//IDC_BUTTON5,
	-1
};

static int iState2 = -1;

static TCHAR szSendText[1024];
static TCHAR szSaveText[2][1024];
static int   iSendTextNo = 0;

static DWORD dwOptions = 0;
#define OPT_CLEARBOX		0x00000001UL
#define OPT_NOMOVEFOCUS		0x00000002UL

////////////////////////////////////////////////////////////////////////////

// Nbv{[h֊tϐ
static LPTSTR lpClipString = NULL;

// Nbv{[hϐ̏
LPTSTR DoInitClipbord(void)
{
	lpClipString = (LPTSTR)LocalAlloc(LMEM_FIXED, 3000);
	return lpClipString;
}

// Nbv{[hϐ̏Iݒ
void DoEndClipbord(void)
{
	LocalFree((HLOCAL)lpClipString);
}

// Nbv{[h擾
LPTSTR DoGetClipboard(HWND hWnd)
{
	HANDLE hClipText;

	if (lpClipString == NULL) return NULL;
	if (OpenClipboard(hWnd) == FALSE) return NULL;

	hClipText = GetClipboardData(CF_UNICODETEXT);
	if (hClipText == NULL) {
		CloseClipboard();
		return NULL;			
	}

	lstrcpy(lpClipString, (LPTSTR)hClipText);
	CloseClipboard();
	return lpClipString;			
}

// Nbv{[hւ̐ݒ
BOOL DoSetClipboard(HWND hWnd, TCHAR szStr[])
{
	HLOCAL hGMem;
	LPTSTR ptr;

	if (OpenClipboard(hWnd)) {
		EmptyClipboard();
		hGMem = LocalAlloc(LMEM_FIXED, (_tcslen(szStr)+1)*sizeof(TCHAR));
		ptr = (LPTSTR)hGMem;
		lstrcpy(ptr, szStr);
		SetClipboardData(CF_UNICODETEXT, hGMem);
		CloseClipboard();
	}

	return TRUE;			
}

////////////////////////////////////////////////////////////////////////////

// gsGetFile.dllgpt@CI[v
BOOL GetOpenFileNameEx(OPENFILENAME* pofn)
{
	HINSTANCE hInst = LoadLibrary(TEXT("gsgetfile.dll"));
	if (hInst) {
		BOOL (*gsGetOpenFileName)(OPENFILENAME* pofn);
		(FARPROC&)gsGetOpenFileName = GetProcAddress(hInst, TEXT("gsGetOpenFileName"));
		if (gsGetOpenFileName) {
			BOOL ret = gsGetOpenFileName(pofn);
			FreeLibrary(hInst);
			return ret;
		}
		FreeLibrary(hInst);
	}
	return GetOpenFileName(pofn);
}

//
INT DoGetFileName(HWND hWnd, LPTSTR szFileName, INT nMax, LPTSTR szOpenFilter)
{
    OPENFILENAME of;

    memset(&of, 0, sizeof(of));				// Initial file open structure

    of.lStructSize = sizeof(of);
    of.hwndOwner   = hWnd;
    of.lpstrFile   = szFileName;
    of.nMaxFile    = nMax;
    of.lpstrFilter = szOpenFilter;
    of.Flags       = 0;

    //if (GetOpenFileName(&of)) {
    if (GetOpenFileNameEx(&of)) {
        return lstrlen(szFileName);
    } else {
        return 0;
	}
}

// ̑荞
int PixSendStrings(HWND hWnd)
{
	TCHAR code[4];
	TCHAR *pr;
	TCHAR *pw;

	pr = pw = szSendText;
	pr++;								// 1ڂ'\\'Ȃ̂ŃXLbv
	while (*pr) {
		if (*pr == _T('\\')) {
			pr++;
			if (*pr == 0) break;
			switch (*pr) {
			case _T('x'):
				pr++;
				code[0] = *pr++;
				code[1] = *pr;
				code[2] = _T('\0');
				*pw   = (TCHAR)wcstoul(code, NULL, 16);
				break;
			case _T('n'):
				*pw = VK_RETURN;
				break;
			case _T('L'):
				*pw = VK_LEFT;
				break;
			case _T('U'):
				*pw = VK_UP;
				break;
			case _T('R'):
				*pw = VK_RIGHT;
				break;
			case _T('D'):
				*pw = VK_DOWN;
				break;
			case _T('W'):
				*pw++ = -1;
				*pw = -1;
				break;
			case _T('C'):				// CTRL
				*pw = VK_CONTROL;
				break;
			case _T('S'):				// SHIFT
				*pw = VK_SHIFT;
				break;
			case _T('A'):				// ALT
				*pw = VK_MENU;
				break;
			case _T('T'):
				*pw++ = VK_LBUTTON;
				pr++;
				code[0] = *pr++;
				code[1] = *pr++;
				code[2] = *pr++;
				code[3] = _T('\0');
				*pw++ = (TCHAR)wcstoul(code, NULL, 10);
				code[0] = *pr++;
				code[1] = *pr++;
				code[2] = *pr;
				code[3] = _T('\0');
				*pw   = (TCHAR)wcstoul(code, NULL, 10);
				break;
			default:
				if (iswlower(*pr)) {
					*pw = toupper(*pr);
				} else if (pw != pr) {
					*pw = *pr;
				}
				break;
			}
		} else if (iswlower(*pr)) {
			*pw = toupper(*pr);
		} else if (pw != pr) {
			*pw = *pr;
		}
		pr++;
		pw++;
	}
	*pw = 0;
	//if (dwOptions & OPT_CLEARBOX) {
	//	DoSetClipboard(hWnd, szSendText);
	//	SendMessage(hWndEdit, WM_SETTEXT, 0, (LPARAM)"");
	//}
	return 0;
}

// 
void StInitialize(void)
{
	int i;
	// sW[̃tpX̎擾
	LPTSTR p;
	DWORD dwRet = GetModuleFileName(NULL, szIniName, sizeof(szIniName));
	if (dwRet) {
		// INIt@Cǂݍ
		p = wcsrchr(szIniName, _T('.'));
		*p = 0;
		wcscat(szIniName, _T(".ini"));
		StIniName(szIniName);
		StLoadData();

		// DATt@Cǂݍ
		*p = 0;
		wcscat(szIniName, _T(".dat"));
		LPTSTR pname = StGetDataPath();
		if (pname) {
			if (ReadFileFreeWord(hWndMain, pname) == TRUE) {
				pname = NULL;
			} else {
				pname = szIniName;
			}
		} else {
			pname = szIniName;
		}
		if (pname) {
			if (ReadFileFreeWord(hWndMain, szIniName) == TRUE) {
				StSetDataPath(szIniName);
			}
		}
		for (i=0; i<2; i++) {
			p = StGetSaveText(i);
			if (p) {
				_tcsncpy(szSaveText[i], p, ARRAY_SIZE(szSaveText[i]));
				szSaveText[i][ARRAY_SIZE(szSaveText[i])-1] = 0;
			} else {
				memset(szSaveText[i], 0, sizeof(szSaveText[i]));
			}
		}
	}
}

// GfBbgRg[
WNDPROC OldProc;
LRESULT CALLBACK PteEditProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static int iFlgEnter = 0;
	SHORT ctrl;

	ctrl  = GetKeyState(VK_LCONTROL);
	ctrl |= GetKeyState(VK_RCONTROL);
	ctrl &= 0x8000;

	switch (message) {
	case WM_KEYDOWN:
		switch (LOWORD(wParam)) {
		case VK_RETURN:
		case 0x0086:		// ANV{^̎VK_RETURNƈꏏɔ
	//	case VK_UP:			// 
	//	case VK_DOWN:		// 
	//		return 1;
	//	case _T('9'):
	//		if (ctrl) return 1;
	//		break;
	//	case _T('8'):
	//		if (ctrl) return 1;
	//		break;
	//	case _T('7'):
	//		if (ctrl) return 1;
	//		break;
	//	case _T('6'):
	//		if (ctrl) return 1;
	//		break;
		default:
			break;
		}
		break;

	case WM_KEYUP:
		switch (LOWORD(wParam)) {
		case VK_RETURN:
			if (StGetOption(PXI_OPT_SENDBYENTER)) {
				iFlgEnter++;
				if (iFlgEnter > 1) {
					SendMessage(hWndMain, WM_COMMAND, IDC_BUTTON2, 0);
					iFlgEnter = 0;
					return 1;
				}
			}
			break;
		case 0x0086:		// ANV{^̎VK_RETURNƈꏏɔ
			break;
		case VK_BACK:
			if (ctrl) SendMessage(hWndEdit, WM_SETTEXT, 0, (LPARAM)"");
			break;
	//	case VK_UP:			// 
	//		SendMessage(hWndMain, WM_COMMAND, IDC_BUTTON6, 0);
	//		iFlgEnter = 0;
	//		return 1;
	//	case VK_DOWN:		// 
	//		SendMessage(hWndMain, WM_COMMAND, IDC_BUTTON2, 0);
	//		iFlgEnter = 0;
	//		return 1;
	//	case _T('9'):
	//		if (ctrl) {
	//			SendMessage(hWndMain, WM_COMMAND, IDC_BUTTON6, 0);
	//		}
	//		iFlgEnter = 0;
	//		return 1;
	//	case _T('8'):
	//		if (ctrl) {
	//			SendMessage(hWndMain, WM_COMMAND, IDC_BUTTON7, 0);
	//		}
	//		iFlgEnter = 0;
	//		return 1;
	//	case _T('7'):
	//		if (ctrl) {
	//			SendMessage(hWndMain, WM_COMMAND, IDC_BUTTON4, 0);
	//		}
	//		iFlgEnter = 0;
	//		return 1;
	//	case _T('6'):
	//		if (ctrl) {
	//			SendMessage(hWndMain, WM_COMMAND, IDC_BUTTON8, 0);
	//		}
	//		iFlgEnter = 0;
	//		return 1;
		default:
			iFlgEnter = 0;
			break;
		}
		break;
	}

	return CallWindowProc(OldProc, hWnd, message, wParam, lParam);
}

//
void PixResizeDialog(HWND hDlg)
{
	RECT rt, rt1;
	int i, x, y, w, h;
	HWND hWndItem;
	POINT pt;

	if (GetWindowRect(hDlg, &rt1)) {
		SystemParametersInfo(SPI_GETWORKAREA, 0, &rt, sizeof(rt));
		iDlgHeight	= rt1.bottom - rt1.top;
		iDlgWidth	= rt.right - rt.left;
		if (iDlgWidth > DLG_WIDTH) {
			iDlgWidth = DLG_WIDTH;
		}
		StPopWinwodPos(&pt);
		if (pt.x < rt.left) {
			pt.x = rt.left;
		} else if (pt.x > rt.right - iDlgWidth) {
			pt.x = rt.right - iDlgWidth;
		}
		if (pt.y < rt.top) {
			pt.y = rt.top;
		} else if (pt.y > rt.bottom - iDlgHeight) {
			pt.y = rt.bottom - iDlgHeight;
		}
		SetWindowPos(hDlg, HWND_TOPMOST, pt.x, pt.y, iDlgWidth, iDlgHeight, SWP_NOACTIVATE);
		//{
		//	TCHAR str[256];
		//	wsprintf(str, _T("%d,%d"), iDlgWidth, iDlgHeight);
		//	MessageBox(hDlg, str, _T("debug"), MB_OK);
		//}

		GetClientRect(hDlg, &rt1);

		hWndItem = GetDlgItem(hDlg, iDlgItemId[1]);
		GetClientRect(hWndItem, &rt);
		w = rt.right  - rt.left;
		h = rt.bottom - rt.top;
		x = rt1.right - w - 2;
		y = rt1.top + 1;
		SetWindowPos(hWndItem, 0, x, y, w, h, SWP_NOZORDER | SWP_NOSIZE);

		for (i=2; iDlgItemId[i] != -1; i++) {
			hWndItem = GetDlgItem(hDlg, iDlgItemId[i]);
			GetClientRect(hWndItem, &rt);
			w = rt.right  - rt.left;
			h = rt.bottom - rt.top;
			x = rt1.right - w*i - 4;
			y = rt1.top + 1;
			SetWindowPos(hWndItem, 0, x, y, w, h, SWP_NOZORDER | SWP_NOSIZE);
		}

		x = rt1.left + 1;
		y = rt1.top + (rt.bottom - rt.top) + 2;		// Ō̃{^̍𗘗p
		GetClientRect(hWndEdit, &rt);
		w = rt1.right - rt1.left - 2;
		h = rt.bottom - rt.top;
		SetWindowPos(hWndEdit, 0, x, y, w, h, SWP_NOZORDER);
	}
}

// WM_INITDIALOG
BOOL DoInitDialog(HWND hDlg)
{
	hWndMain = hDlg;
	hWndEdit = GetDlgItem(hDlg, IDC_EDIT1);

	// X[ACR̓o^
	HICON hIcon = (HICON)SendMessage(hDlg, WM_GETICON, 0, 0);
	if (hIcon == 0) {
		hIcon = (HICON)LoadImage(g_hInst, MAKEINTRESOURCE(IDI_ICON1),
					IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
		SendMessage(hDlg, WM_SETICON, FALSE, (LPARAM)hIcon);
	}

	// GfBbgRg[̃TuNX
	OldProc = (WNDPROC)SetWindowLong(hWndEdit, GWL_WNDPROC, (LONG)PteEditProc);

	// ݒ
	DoInitClipbord();
	StInitialize();

	PixResizeDialog(hDlg);
	SetWindowPos(hDlg, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);
	ShowWindow(hDlg, SW_SHOW);
	SetForegroundWindow(hDlg);

	SetWindowText(hDlg, TITLE);

	return TRUE; 
}

// zL[R[h̑M
int PixSendKey()
{
	UINT flag;
	DWORD dx, dy;

	flag = 0;
	for (TCHAR *p = szSendText; *p != 0; p++) {
		switch (*p) {
		case -1:
			// nop
			break;
		case VK_CONTROL:
			if (flag & 0x00000001UL) {
				keybd_event((BYTE)*p, 0, KEYEVENTF_KEYUP | KEYEVENTF_SILENT, 0);
			} else {
				keybd_event((BYTE)*p, 0, KEYEVENTF_SILENT, 0);
			}
			flag ^= 0x00000001UL;
			break;
		case VK_SHIFT:
			if (flag & 0x00000002UL) {
				keybd_event((BYTE)*p, 0, KEYEVENTF_KEYUP | KEYEVENTF_SILENT, 0);
			} else {
				keybd_event((BYTE)*p, 0, KEYEVENTF_SILENT, 0);
			}
			flag ^= 0x00000002UL;
			break;
		case VK_MENU:
			if (flag & 0x00000004UL) {
				keybd_event((BYTE)*p, 0, KEYEVENTF_KEYUP | KEYEVENTF_SILENT, 0);
			} else {
				keybd_event((BYTE)*p, 0, KEYEVENTF_SILENT, 0);
			}
			flag ^= 0x00000004UL;
			break;
		case VK_LBUTTON:
			p++;
			dx = *p++;
			dy = *p;
			dx *= 65535 / GetSystemMetrics(SM_CXSCREEN);
			dy *= 65535 / GetSystemMetrics(SM_CYSCREEN);
			mouse_event(MOUSEEVENTF_ABSOLUTE | MOUSEEVENTF_LEFTDOWN, dx, dy, 0, 0);
			mouse_event(MOUSEEVENTF_ABSOLUTE | MOUSEEVENTF_LEFTUP,   dx, dy, 0, 0);
			break;
		default:
			keybd_event((BYTE)*p, 0, KEYEVENTF_SILENT, 0);
			keybd_event((BYTE)*p, 0, KEYEVENTF_KEYUP | KEYEVENTF_SILENT, 0);
			break;
		}
		Sleep(250);
	}
	if (flag & 0x0001) {
		keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP | KEYEVENTF_SILENT, 0);
	}
	if (flag & 0x0002) {
		keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP | KEYEVENTF_SILENT, 0);
	}
	if (flag & 0x0004) {
		keybd_event(VK_MENU, 0, KEYEVENTF_KEYUP | KEYEVENTF_SILENT, 0);
	}
	return 0;
}

// WM_TIMER
BOOL DoTimer(HWND hWnd, WPARAM wParam)
{
	KillTimer(hWnd, wParam);

	switch (wParam) {
	case 1:
		break;

	case 2:

		switch (iState2) {
		case 0x0200:
		case 0x0400:
			SetWindowPos(hWnd, HWND_BOTTOM, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_HIDEWINDOW);
			SetTimer(hWnd, 2, 250, NULL);
			iState2++;
			break;
		case 0x0201:
		case 0x0401:
			PixSendKey();
			SetTimer(hWnd, 2, 100, NULL);
			iState2++;
			break;
		case 0x0202:
			SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
			SetForegroundWindow(hWnd);
			if (dwOptions & OPT_CLEARBOX) {
				dwOptions &= ~OPT_CLEARBOX;
				SendMessage(hWndEdit, WM_SETTEXT, 0, (LPARAM)"");
			}
			if (dwOptions & OPT_NOMOVEFOCUS) {
				dwOptions &= ~OPT_NOMOVEFOCUS;
			} else {
				SetFocus(hWnd);
			}
			iState2 = -1;
			break;
		case 0x0402:
			SendMessage(hWnd, WM_COMMAND, IDCANCEL, (LPARAM)0);
			iState2 = -1;
			break;

		case 0x0100:
		case 0x0300:
			SetWindowPos(hWnd, HWND_BOTTOM, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_HIDEWINDOW);
			SetTimer(hWnd, 2, 250, NULL);
			iState2++;
			break;
		case 0x0101:
		case 0x0301:
			keybd_event(VK_CONTROL, 0, KEYEVENTF_SILENT, 0);
			keybd_event(0x0056, 0, KEYEVENTF_SILENT, 0);
			keybd_event(0x0056, 0, KEYEVENTF_KEYUP | KEYEVENTF_SILENT, 0);
			keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP | KEYEVENTF_SILENT, 0);
			SetTimer(hWnd, 2, 250, NULL);
			iState2++;
			break;
		case 0x0302:
			SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
			SetForegroundWindow(hWnd);
			if (dwOptions & OPT_CLEARBOX) {
				dwOptions &= ~OPT_CLEARBOX;
				SendMessage(hWndEdit, WM_SETTEXT, 0, (LPARAM)"");
			}
			if (dwOptions & OPT_NOMOVEFOCUS) {
				dwOptions &= ~OPT_NOMOVEFOCUS;
			} else {
				SetFocus(hWnd);
			}
			iState2 = -1;
			break;
		case 0x0102:
			SendMessage(hWnd, WM_COMMAND, IDCANCEL, (LPARAM)0);
			iState2 = -1;
			break;
		}
		break;
	}

	return TRUE;
}

// Mesage handler for the About box.
BOOL CALLBACK DlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static int iX = 0;
	static int iY = 32;
	static BOOL flag = FALSE;
	static RECT drc = {0,0,0,0};
	POINT pt;
	int res;
	TCHAR buf[4];
	int btn;

	btn = 0;

	switch (message)
	{
		case WM_INITDIALOG:
			return DoInitDialog(hDlg);

		case WM_SETTINGCHANGE :
			{
				RECT rt, rtd;
				SystemParametersInfo(SPI_GETWORKAREA, 0, &rt, sizeof(rt));
				GetWindowRect(hDlg, &rtd);
				pt.x = rtd.left;
				pt.y = rtd.top;
				if (pt.x < rt.left) {
					pt.x = rt.left;
				} else if (rtd.left + iDlgWidth  > rt.right ) {
					pt.x = rt.right - iDlgWidth;
				}
				if (pt.y < rt.top) {
					pt.y = rt.top;
				} else if (rtd.top  + iDlgHeight > rt.bottom) {
					pt.y = rt.bottom - iDlgHeight;
				}
				SetWindowPos(hDlg, 0, pt.x, pt.y, iDlgWidth, iDlgHeight, SWP_NOZORDER);
				SetForegroundWindow(hDlg);
				SetFocus(hWndEdit);
				//{
				//	TCHAR mes[80];
				//	wsprintf(mes, _T("(%d,%d) (%d,%d)-(%d,%d)"), pt.x, pt.y, rtd.left, rtd.top, rtd.right, rtd.bottom);
				//	MessageBox(hDlg, mes, _T("debug"), MB_OK);
				//}
			}
			return TRUE;

		case WM_DESTROY:
			{
				int i;
				for (i=0; i<2; i++) StSetSaveText(szSaveText[i], i);
			}
			StSaveData();
			DoEndClipbord();
			(WNDPROC)SetWindowLong(hWndEdit, GWL_WNDPROC, (LONG)OldProc);
			break;

		case WM_LBUTTONDOWN:
			if (!flag) {
				GetWindowRect(hDlg, &drc);
				iX = LOWORD(lParam);
				iY = HIWORD(lParam);
				SetCapture(hDlg);
				flag = TRUE;
				return TRUE; 
			}
			break;

		case WM_MOUSEMOVE:
			{
				static int ff = 0;
				ff++;
				if (ff > 5) {				// Ԉ
					ff=0;
					break;
				}
			}
			if (flag) {
				pt.x = (short)LOWORD(lParam) - iX;
				pt.y = (short)HIWORD(lParam) - iY;		// 2̕␔̒l̂shortɃLXg
				ClientToScreen(hDlg, &pt);
				{
					RECT rt;
					SystemParametersInfo(SPI_GETWORKAREA, 0, &rt, sizeof(rt));
					if (pt.x < rt.left) pt.x = rt.left;
					if (pt.y < rt.top ) pt.y = rt.top;
					if (pt.x + iDlgWidth  > rt.right ) pt.x = rt.right  - iDlgWidth;
					if (pt.y + iDlgHeight > rt.bottom) pt.y = rt.bottom - iDlgHeight;
				}
				SetWindowPos(hDlg, 0, pt.x, pt.y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
				return TRUE;
			}
			break;

		case WM_LBUTTONUP:
			if (flag) {
				pt.x = (short)LOWORD(lParam) - iX;
				pt.y = (short)HIWORD(lParam) - iY;
				ClientToScreen(hDlg, &pt);
				{
					RECT rt;
					SystemParametersInfo(SPI_GETWORKAREA, 0, &rt, sizeof(rt));
					if (pt.x < rt.left) pt.x = rt.left;
					if (pt.y < rt.top ) pt.y = rt.top;
					if (pt.x + iDlgWidth  > rt.right ) pt.x = rt.right  - iDlgWidth;
					if (pt.y + iDlgHeight > rt.bottom) pt.y = rt.bottom - iDlgHeight;
				}
				SetWindowPos(hDlg, 0, pt.x, pt.y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
				StPushWinwodPos(&pt);
				flag = FALSE;
				ReleaseCapture();
				return TRUE;
			}
			break;

		case WM_SETFOCUS:
			SetFocus(hWndEdit);
			return TRUE; 

		case WM_TIMER:
			DoTimer(hDlg, wParam);
			break;

		case WM_COMMAND:
			switch (LOWORD(wParam)) {
			case IDCANCEL:
			case IDC_BUTTON1:
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;

			case IDOK:
				if (SendMessage(hWndEdit, WM_GETTEXTLENGTH, 0, 0)) {
					SendMessage(GetDlgItem(hDlg, IDC_EDIT1), EM_SETSEL, 0, -1);
					SendMessage(GetDlgItem(hDlg, IDC_EDIT1), WM_COPY, 0, 0);
					iState2 = 0x0100;
					SetTimer(hDlg, 2, 100, NULL);
				}
				return TRUE;

			case IDC_BUTTON8:		// 1
				btn = 1;
				// Ďs
			case IDC_BUTTON6:		// 2
				if (btn == 0) btn = 2;
				iSendTextNo = 1 & (btn >> 1);
				if (SendMessage(hWndEdit, WM_GETTEXTLENGTH, 0, 0) == 0) {
					if ((szSaveText[iSendTextNo][0] == _T('\\')) &&
						(szSaveText[iSendTextNo][1] == _T('\\'))) {
						lstrcpy(szSendText, szSaveText[iSendTextNo]);
						PixSendStrings(hDlg);
						if (StGetOption(PXI_OPT_ENDAFTERSEND)) {
							iState2 = 0x0400;
						} else {
							iState2 = 0x0200;
						}
						dwOptions = OPT_NOMOVEFOCUS;
						SetTimer(hDlg, 2, 100, NULL);
					} else if (szSaveText[iSendTextNo][0]) {
						DoSetClipboard(hDlg, szSaveText[iSendTextNo]);
						if (StGetOption(PXI_OPT_ENDAFTERSEND)) {
							iState2 = 0x0100;
						} else {
							iState2 = 0x0300;
						}
						dwOptions = OPT_NOMOVEFOCUS;
						SetTimer(hDlg, 2, 100, NULL);
					}
					return TRUE;
				}
				dwOptions = OPT_NOMOVEFOCUS;
				// Ďs
			case IDC_BUTTON2:		// 
				SendMessage(hWndEdit, WM_GETTEXT, ARRAY_SIZE(buf), (LPARAM)buf);
				if (buf[0] == _T('\0')) {
					// 
				} else if ((buf[0] == _T('\\')) && (buf[1] == _T('\\'))) {
					SendMessage(hWndEdit, WM_GETTEXT, ARRAY_SIZE(szSendText), (LPARAM)szSendText);
					if (btn) lstrcpy(szSaveText[iSendTextNo], szSendText);
					PixSendStrings(hDlg);
					if (StGetOption(PXI_OPT_ENDAFTERSEND)) {
						iState2 = 0x0400;
					} else {
						iState2 = 0x0200;
					}
					dwOptions |= OPT_CLEARBOX;
					SetTimer(hDlg, 2, 100, NULL);
				} else {
					SendMessage(hWndEdit, WM_GETTEXT, ARRAY_SIZE(szSendText), (LPARAM)szSendText);
					DoSetClipboard(hDlg, szSendText);
					if (btn) lstrcpy(szSaveText[iSendTextNo], szSendText);
					if (StGetOption(PXI_OPT_ENDAFTERSEND)) {
						iState2 = 0x0100;
					} else {
						iState2 = 0x0300;
					}
					dwOptions |= OPT_CLEARBOX;
					SetTimer(hDlg, 2, 100, NULL);
				}
				return TRUE;

			case IDC_BUTTON4:		// 
				SetWindowPos(hDlg, HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_HIDEWINDOW);
				DialogBox(g_hInst, MAKEINTRESOURCE(IDD_DIALOG_SETTING), NULL, (DLGPROC)DlgSetting);
				SetWindowPos(hDlg, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
				SetForegroundWindow(hDlg);
				SetFocus(hWndEdit);
				return TRUE;

			case IDC_BUTTON7:		// 
				SetWindowPos(hDlg, HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_HIDEWINDOW);
				res = DialogBox(g_hInst, MAKEINTRESOURCE(IDD_DIALOG_BRACKETS), NULL, (DLGPROC)DlgBrackets);
				SetWindowPos(hDlg, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
				SetForegroundWindow(hDlg);
				SetFocus(hWndEdit);
				return TRUE;

			//case IDC_BUTTON2:		// 
			//	iLastBtn = IDC_BUTTON2;
			//	SendMessage(GetDlgItem(hDlg, IDC_EDIT1), EM_SETSEL, 0, -1);
			//	SendMessage(GetDlgItem(hDlg, IDC_EDIT1), WM_COPY, 0, 0);
			//	if (StGetOption(PXI_OPT_ENDAFTERSEND)) {
			//		iState2 = 0x0100;
			//	} else {
			//		iState2 = 0x0300;
			//	}
			//	SetTimer(hDlg, 2, 100, NULL);
			//	return TRUE;
			//case IDC_BUTTON6:		// 
			//	iLastBtn = IDC_BUTTON6;
			//	SendMessage(hWndEdit, WM_GETTEXT, sizeof(szSendText)/sizeof(TCHAR), (LPARAM)szSendText);
			//	dwOptions |= OPT_CLEARBOX;
			//	// Ďs
			//case IDC_BUTTON8:		// g[t
			//	PixSendStrings(hDlg);
			//	iState2 = 0x0200;
			//	SetTimer(hDlg, 2, 100, NULL);
			//	return TRUE;
			//case IDC_BUTTON3:		// 
			//	SelectFullpath(hDlg);
			//	SetFocus(hWndEdit);
			//	return TRUE;
			//case IDC_BUTTON5:		// 
			//	SetWindowPos(hDlg, HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_HIDEWINDOW);
			//	DialogBox(g_hInst, MAKEINTRESOURCE(IDD_DIALOG_WINLIST), NULL, (DLGPROC)WinlistDlgFunc);
			//	SetWindowPos(hDlg, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
			//	SetForegroundWindow(hDlg);
			//	SetFocus(hWndEdit);
			//	return TRUE;
			//case IDC_BUTTON4:		// 
			//	SendMessage(hWndEdit, WM_SETTEXT, 0, (LPARAM)"");
			//	SetFocus(hWndEdit);
			//	return TRUE;
			case IDC_STATIC1:
				return TRUE;
			}
			break;
	}
    return FALSE;
}

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
 	// TODO: ̈ʒuɃR[hLqĂB
	//If it is already running, then focus on the window
	HWND hWnd = FindWindow(_T("Dialog"), TITLE);	
	if (hWnd) 
	{
		// set focus to foremost child window
		// The "| 0x01" is used to bring any owned windows to the foreground and
		// activate them.
		SetForegroundWindow((HWND)((ULONG) hWnd | 0x00000001));
		return 0;
	} 

	g_hInst = hInstance;
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), NULL, (DLGPROC)DlgProc);

	return 0;
}
